<?php 

$target_dir="TC";
$pname="ATS";
$tc_cmd="runtcast.bat"; //note: this assumes TC/ATS project !
$exec_cmd="exec_script.exe";  //note: this assumes ATS project name!
$loop_cmd="loopback\LoopbackSUT_NC.exe";
$bcast_cmd="broadcast\InterLoopbackAdapter.exe";
$extern_cmd="java -jar external\external.jar";
$quit_cmd="quit_script.exe";  //note: this assumes ATS project name!

//read compiled filelist
$complist=array();
if($handle = opendir($target_dir."/bin")) {
 while (false !== ($fname = readdir($handle))) {
  if ( substr($fname,0,1) != "." ) {
   $fname=substr($fname,0,strpos($fname,"."));
   $complist[]=$fname;
  }
 }
 closedir($handle);
}

$error_list=array(); //list of wrong compilation/execution results
$exec_list=array(); //list of tcs to be executed

$resfile=fopen("Execution_log.csv","w");
$logfile=fopen("Unexpected_execution_results.txt","w");

$excount=1;


//go through list of files to execute
$pfile=file($target_dir."/".$pname.".tcproj");
$ufile=file($target_dir."/".$pname.".tcproj.user");

$mf_index=0;
 for($i=0;$i<sizeof($ufile);$i++) {
  if(strpos($ufile[$i],"main_script")!=FALSE) $mf_index=$i;
 }

for($i=0;$i<sizeof($pfile);$i++) {

  $pfile[$i]=chop($pfile[$i]);
  $pfile[$i]=substr($pfile[$i],strpos($pfile[$i],"<"));

  if(substr($pfile[$i],0,6)=='<name>') {
   $endtag=strpos($pfile[$i],"</");
   $out_name=substr($pfile[$i],6,$endtag-6);
   $compiled=FALSE;
   for($j=0;$j<sizeof($complist);$j++) {
   	   if($complist[$j]==$out_name) {
   	     $compiled=TRUE;
   	    // echo "|comp: $out_name |";
   	     break;
   	   }
   }
   //if($compiled==FALSE) echo "|nc: $out_name |";
   
   $nline=chop($pfile[$i+1]);
   $nline=substr($nline,strpos($nline,"<"));
   $endtag=strpos($nline,"</");
   $in_name=substr($nline,6,$endtag-6);
   
   //check if the file should compile, and the type of adapter to use
   $content=file($target_dir."/".$in_name);
   $c_result="unknown";
   $v_result="unknown";
   $l_result="unknown";
   $adapter="loopback";	//default value
   $execute=0;
   for($j=0;$j<sizeof($content);$j++) {
     if(strpos($content[$j],"@verdict")!=FALSE) {
       if(strpos($content[$j],"accept")!=FALSE) $c_result="accept";
       if(strpos($content[$j],"reject")!=FALSE) $c_result="reject";

       if(strpos($content[$j],"ttcn3verdict:pass")!=FALSE) $v_result="pass";
       if(strpos($content[$j],"ttcn3verdict:fail")!=FALSE) $v_result="fail";
       if(strpos($content[$j],"ttcn3verdict:error")!=FALSE) $v_result="error";
       if(strpos($content[$j],"ttcn3verdict:inconc")!=FALSE) $v_result="inconc";
       if(strpos($content[$j],"ttcn3verdict:none")!=FALSE) $v_result="none";
      if(strpos($content[$j],"noexecution")!=FALSE) $v_result="noexec";  //these syn cases
     }
     if(strpos($content[$j],"@configuration")!=FALSE) {
      if(strpos($content[$j],"port:")!=FALSE) {
      	 if(substr($content[$j],strpos($content[$j],"port:")+5,9)=="broadcast") $adapter="external";
      }
      if(strpos($content[$j],"external_functions")!=FALSE) $adapter="broadcast";
     }
     if(strpos($in_name,"_import")!==FALSE) $c_result="import";
   }
   
   if( ($c_result=="accept")&&($compiled==FALSE) ) { $error_list[]=$in_name; fputs($logfile,"\n".$in_name); }
   
   if( ($c_result=="reject")&&($compiled==TRUE) ) $execute=1;

   if( ($c_result=="accept")&&($compiled==TRUE)&&($v_result!="noexec") ) $execute=1;

   if( $c_result=="unknown") { $error_list[]=$in_name; fputs($logfile,"\n".$in_name); }

   if( (substr($in_name,-4,4)=="ttcn")&&(substr($in_name,0,3)!="Sem")&&(substr($in_name,0,3)!="Syn")&&(substr($in_name,0,6)!="NegSem")&&(substr($in_name,0,6)!="NegSyn") ) echo "\nfile name in wrong format: $in_name ";   

 //now execute if needed
   if($execute==1) {
    $ufile[$mf_index]=" <main_script>$out_name</main_script>\r\n";
     
    $wfile=fopen($target_dir."/".$pname.".tcproj.user","w");
    for($k=0;$k<sizeof($ufile);$k++) fputs($wfile,$ufile[$k]);
    fclose($wfile);

    pclose(popen("start /B ". $tc_cmd, "r"));
    sleep(20);	//must give enough time to startup TC and load project (12 sec is limit, rest is safeguard)
    system($exec_cmd);
    sleep(1);
    //select the right adapter
    if($adapter=="broadcast") system($bcast_cmd);
    else if($adapter=="external") system($extern_cmd);
    else system($loop_cmd);
    
    system($quit_cmd);
    sleep(1);
    
    //get into the session directory and read verdict
if($handle = opendir($target_dir)) {
 while (false !== ($fname = readdir($handle))) {
  if ( substr($fname,0,1) != "." ) { 
   if ( substr($fname,0,7) == "Session" ) {
    $lfile=file($target_dir."/".$fname."/session_report.xml");
    $l_result="unknown";
    for($k=0;$k<sizeof($lfile);$k++) {
     if(strpos($lfile[$k],"<verdict>")!=FALSE) {	//go through all tags
      $vind=strpos($lfile[$k],"<verdict>")+9;
      if(substr($lfile[$k],$vind,4)=="none") {
      	    if($l_result=="unknown")  $l_result="none";
      }
      if(substr($lfile[$k],$vind,6)=="inconc") {
      	  if(($l_result=="unknown")||($l_result=="none")) $l_result="inconc";
      }
      if(substr($lfile[$k],$vind,4)=="pass") {
      	  if(($l_result=="unknown")||($l_result=="none")||($l_result=="inconc")) $l_result="pass";
      }
      if(substr($lfile[$k],$vind,4)=="fail") {
      	  if(($l_result=="unknown")||($l_result=="none")||($l_result=="pass")||($l_result=="inconc")) $l_result="fail";
      }
      if(substr($lfile[$k],$vind,5)=="error") $l_result="error";
     }
    }
    if($l_result=="unknown") {	//now check for runtime exception
     $lfile=file($target_dir."/".$fname."/session_log.xmmlog");
     for($k=0;$k<sizeof($lfile);$k++) {
     	if(strpos($lfile[$k],"<err>")!=FALSE) {
     	 $l_result="error";
     	}
     }
    }
    
    if( ($c_result=="accept")&&($l_result!=$v_result) ) { $error_list[]=$in_name; fputs($logfile,"\n".$in_name); }
    if( ($c_result=="reject")&&($l_result!="error") ) { $error_list[]=$in_name; fputs($logfile,"\n".$in_name); }

    //delete session directory
    rrmdir($target_dir."/".$fname);
   }
  }
 }
 closedir($handle);
}
   
    
   }
   
   if($c_result!="import") {	//don't generate output for import files
    fputs($resfile,"$excount,$in_name,");
    if($compiled==TRUE) fputs($resfile,"accepted,$l_result\n");
    else fputs($resfile,"rejected,rejected\n");
    $excount++;
   }
   
  }
  
}

fclose($resfile);
fclose($logfile);

echo "\n Listing of unexpected execution results: ";
print_r($error_list);


 function rrmdir($dir) { 
   if (is_dir($dir)) { 
     $objects = scandir($dir); 
     foreach ($objects as $object) { 
       if ($object != "." && $object != "..") { 
         if (filetype($dir."/".$object) == "dir") rrmdir($dir."/".$object); else unlink($dir."/".$object); 
       } 
     } 
     reset($objects); 
     rmdir($dir); 
   } 
 } 
 
?>
